
      // This program is for demonstration purposes only.
      // It works well for it's intended purpose, but is NOT suitable
      // for any other uses.  DO NOT INSTALL THIS PROGRAM INTO PRODUCTION.
      // Pay close attention to the disclaimer that follows.
      // TODO: Write software that can reach out of the computer and force
      //       the user to actually read, and acknowledge, this disclaimer
      //       and promise not to use this program for anything other
      //       than it's intended demonstration purposes.
      // THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
      // WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
      // WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
      // THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
      // CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
      // FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
      // CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
      // OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

       Ctl-Opt  debug option(*NODEBUGIO : *SRCSTMT);
       Ctl-Opt  dftactgrp(*no) actgrp('PBTEST');

       dcl-f  CRDTCARD   keyed     usage(*update : *output);
       dcl-f  CC1_DSPF   workstn   indds(dspf_inds)
                                   infds(dspf_info);

       dcl-ds
         dspf_inds;
           S1_Errors               char(2)  pos(30);
             S1Id_ERROR            ind      pos(30);
             S1Number_ERROR        ind      pos(31);
           S1Id_PROTECT            ind      pos(32);
       end-ds;

       dcl-ds
         dspf_info;
            keyPressed  char(1)  pos(369);
       end-ds;

       dcl-c   F03                 x'33';
       dcl-c   F06                 x'36';
       dcl-c   ENTER               x'F1';
       dcl-c   PAGEUP              x'F4';
       dcl-c   PAGEDOWN            x'F5';


       Exsr GetNextRec;
       dou keyPressed = F03;

            Exfmt SCRN1;
            Clear S1_Errors;
            Clear S1ERRMSG;

            Select;

                When keyPressed = F03;
                  // don't do anything

                When keyPressed = F06;
                  Exsr AddRec;

                When keyPressed = ENTER;
                  Exsr UpdateRec;

                When keyPressed = PAGEUP;
                  Exsr GetPrevRec;

                When keyPressed = PAGEDOWN;
                  Exsr GetNextRec;

            endsl;

       enddo;

       *inlr = *on;
       return;

      //-----------------------------------------------------------------------
      // Add new record
      //-----------------------------------------------------------------------
       Begsr AddRec;

            Clear SCRN1;
            S1Id_PROTECT = *off;

            dou keyPressed = F03
            or  (keyPressed = ENTER and S1_Errors = *zeros);

                 Exfmt SCRN1;
                 Clear S1_Errors;
                 Clear S1ERRMSG;

                 if keyPressed = ENTER;

                    // Validate the ID (must be unique)
                     setll (S1ID) CRDTCARD;
                     if %equal(CRDTCARD);
                         S1ERRMSG = 'Card ID already exists';
                         S1Id_ERROR = *on;
                     endif;

                    // If everything's valid, write the record
                     if S1_Errors = *zeros;
                         CARDID = S1ID;
                         NUMBER = S1NUMBER;
                         Write CARDR;
                         S1ERRMSG = 'Record added';

                         Setll (S1ID) CRDTCARD;
                         Exsr GetNextRec;
                     endif;
                 endif;

            enddo;

            Clear keyPressed;

       Endsr;

      //-----------------------------------------------------------------------
      // Update record
      //-----------------------------------------------------------------------
       Begsr UpdateRec;
            NUMBER = S1NUMBER;
            Update CARDR;
            S1ERRMSG = 'Record updated';

            Setll (S1ID) CRDTCARD;
            Exsr GetNextRec;
       Endsr;

      //-----------------------------------------------------------------------
      // Get next record
      //-----------------------------------------------------------------------
       Begsr GetNextRec;
            read CRDTCARD;
            if %eof(CRDTCARD);
                 S1ERRMSG = 'End of records';
                 Chain (S1ID) CRDTCARD;
            else;
                 S1ID     = CARDID;
                 S1NUMBER = NUMBER;
                 S1Id_PROTECT = *on;
            endif;
       Endsr;

      //-----------------------------------------------------------------------
      // Get previous record
      //-----------------------------------------------------------------------
       Begsr GetPrevRec;
            readp CRDTCARD;
            if %eof(CRDTCARD);
                 S1ERRMSG = 'Beginning of records';
                 Chain (S1ID) CRDTCARD;
            else;
                 S1ID     = CARDID;
                 S1NUMBER = NUMBER;
                 S1Id_PROTECT = *on;
            endif;
       Endsr;
 